<?php
	wp_enqueue_style('wp-iv_directories-myaccount-style-11', wp_iv_directories_URLPATH . 'admin/files/css/iv-bootstrap.css');
	wp_enqueue_script('iv_directories-myaccount-style-12', wp_iv_directories_URLPATH . 'admin/files/js/bootstrap.min.js');
	global $wpdb, $post;
	global $current_user;
	$curr_post_id=$post->ID;
?>
<div class="bootstrap-wrapper">
 	<div class="welcome-panel container-fluid">
		<?php
			global $wpdb;
			// Check Max\
			$package_id=get_user_meta($current_user->ID,'iv_directories_package_id',true);
			$max=get_post_meta($package_id, 'iv_directories_package_max_post_no', true);
			$current_post = $curr_post_id;
			$post_edit = get_post($curr_post_id);
			$title = $post_edit->post_title;
			$content = $post_edit->post_content;
			$post_type=$post_edit->post_type;
		?>
		<div class="row">
			<div class="col-md-12">
				<div class=" row form-group ">
					<label for="text" class=" col-md-5 control-label"><?php esc_html_e('Logo','ivdirectories'); ?>  </label>
					<?php
						$logo_image_id=get_post_meta($curr_post_id ,'logo_image_id',true);
					?>
					<div class="col-md-4" id="logo_image_div">
						<a  href="javascript:void(0);" onclick="logo_post_image('logo_image_div');"  >
							<?php
								if($logo_image_id>0){
									echo '<img width="100px" src="'. wp_get_attachment_url( $logo_image_id ).'">';
									}else{
									echo '<img width="100px" src="'. wp_iv_directories_URLPATH.'assets/images/image-add-icon.png">';
								}
							?>
						</a>
					</div>
					<input type="hidden" name="logo_image_id" id="logo_image_id" value="<?php echo esc_html($logo_image_id); ?>">
					<div class="col-md-3" id="logo_image_edit">
						<button type="button" onclick="logo_post_image('logo_image_div');"  class="btn btn-xs green-haze"><?php esc_html_e('Add','ivdirectories'); ?> </button>
					</div>
				</div>
				<div class=" row form-group ">
					<label for="text" class=" col-md-5 control-label"><?php esc_html_e('Image Gallery','ivdirectories'); ?>
						<button type="button" onclick="edit_gallery_image('gallery_image_div');"  class="btn btn-xs green-haze"><?php esc_html_e('Add Images','ivdirectories'); ?></button>
					</label>
				</div>
				<div class=" row form-group ">
					<?php
						$gallery_ids=get_post_meta($curr_post_id ,'image_gallery_ids',true);
						$gallery_ids_array = array_filter(explode(",", $gallery_ids));
					?>
					<input type="hidden" name="gallery_image_ids" id="gallery_image_ids" value="<?php echo esc_html($gallery_ids); ?>">
					<div class="col-md-12" id="gallery_image_div">
						<?php
							if(sizeof($gallery_ids_array)>0){
								foreach($gallery_ids_array as $slide){
								?>
								<div id="gallery_image_div<?php echo esc_html($slide);?>" class="col-md-2"><img  class="img-responsive"  src="<?php echo wp_get_attachment_url( $slide ); ?>"><button type="button" onclick="remove_gallery_image('gallery_image_div<?php echo esc_html($slide);?>', <?php echo esc_html($slide);?>);"  class="btn btn-xs btn-danger"><?php esc_html_e('Remove', 'ivdirectories' ); ?></button> </div>
								<?php
								}
							}
						?>
					</div>
				</div>
				<div class=" form-group">
					<label for="text" class=" control-label"><?php esc_html_e('Address','ivdirectories'); ?></label>
					<div class=" ">
						<input type="text" class="form-control" name="address" id="address" value="<?php echo get_post_meta($post_edit->ID,'address',true); ?>" placeholder="<?php esc_html_e('Enter address Here','ivdirectories'); ?>">
					</div>
				</div>
				<div class=" form-group">
					<label for="text" class=" control-label"><?php esc_html_e('City','ivdirectories'); ?></label>
					<div class=" ">
						<input type="text" class="form-control" name="city" id="city" value="<?php echo get_post_meta($post_edit->ID,'city',true); ?>" placeholder="<?php esc_html_e('Enter city ','ivdirectories'); ?>">
					</div>
					<div class=" form-group">
						<label for="text" class=" control-label"><?php esc_html_e('Zipcode','ivdirectories'); ?></label>
						<div class=" ">
							<input type="text" class="form-control" name="postcode" id="postcode" value="<?php echo get_post_meta($post_edit->ID,'postcode',true); ?>" placeholder="<?php esc_html_e('Enter Zipcode ','ivdirectories'); ?>">
						</div>
						<div class=" form-group">
							<label for="text" class=" control-label"><?php esc_html_e('State','ivdirectories'); ?></label>
							<input type="text" class="form-control" name="state" id="state" value="<?php echo get_post_meta($post->ID,'state',true); ?>" placeholder="<?php esc_html_e('Enter state ','ivdirectories'); ?>">
						</div>
						<div class=" form-group">
							<label for="text" class=" control-label"><?php esc_html_e('Country','ivdirectories'); ?></label>
							<input type="text" class="form-control" name="country" id="country" value="<?php echo get_post_meta($post->ID,'country',true); ?>" placeholder="<?php esc_html_e('Enter country ','ivdirectories'); ?>">
						</div>
						<div class=" form-group">
							<label for="text" class=" control-label"><?php esc_html_e('Latitude','ivdirectories'); ?></label>
							<input type="text" class="form-control" name="latitude" id="latitude" value="<?php echo get_post_meta($post->ID,'latitude',true); ?>" placeholder="<?php esc_html_e('Enter latitude ','ivdirectories'); ?>">
						</div>
						<div class=" form-group">
							<label for="text" class=" control-label"><?php esc_html_e('Longitude','ivdirectories'); ?></label>
							<input type="text" class="form-control" name="longitude" id="longitude" value="<?php echo get_post_meta($post->ID,'longitude',true); ?>" placeholder="<?php esc_html_e('Enter longitude ','ivdirectories'); ?>">
						</div>
						<div class="clearfix"></div>
						<?php
								$campuses=get_option('campuses');
								if($campuses==""){$campuses='yes';}
								if($campuses=="yes"){				
								?>	
							<div class="panel panel-default">
										<div class="panel-heading">
											<h4 class="panel-title col-lg-10">
												<a data-toggle="collapse" data-parent="#accordion" href="#add_campuses90">
													<?php esc_html_e('Campuses','ivdirectories'); ?>
												</a>
											</h4>
											<h4 class="panel-title">
												<a data-toggle="collapse" data-parent="#accordion" href="#add_campuses90">
													<?php esc_html_e('[ Edit ]','ivdirectories'); ?>
												</a>
											</h4>
										</div>
										<div id="add_campuses90" class="panel-collapse collapse">
											<div class="panel-body">
											<div id="campuses">
														<?php	$aw=0;
															for($i=0;$i<50;$i++){
																if(get_post_meta($post_edit->ID,'campuse_title'.$i,true)!='' || get_post_meta($post_edit->ID,'campuse_state'.$i,true) ){?>
																
																	<div id="campuse_delete_<?php echo esc_html($i); ?>">
																												
																			<input type="text" class="col-md-8 " name="campuse_title[]" id="campuse_title[]" value="<?php echo get_post_meta($post_edit->ID,'campuse_title'.$i,true); ?>" placeholder="<?php esc_html_e('Campuse Name','ivdirectories'); ?>">	
																			<input type="text" class=" col-md-2" name="campuse_state[]" id="campuse_state[]" value="<?php echo get_post_meta($post_edit->ID,'campuse_state'.$i,true); ?>" placeholder="<?php esc_html_e('State','ivdirectories'); ?>">
																			<input type="text" class="col-md-1" name="campuse_rate[]" id="campuse_rate[]" value="<?php echo get_post_meta($post_edit->ID,'campuse_rate'.$i,true); ?>" placeholder="<?php esc_html_e('Campuse Rating','ivdirectories'); ?>">
																			<span class="pull-right col-md-1"  >
																				<button type="button" onclick="campuse_delete(<?php echo esc_html($i); ?>);"  class="btn btn-xs btn-danger ">X</button>
																			</span>
																			
																	</div>
																
																<div class="clearfix"><hr></div>
																
																<?php
																	$aw++;
																}
															}
															 ?>															
															<div id="campuse" class=" form-group " style=" display: none;">
																	<input type="text" class="col-md-8 " name="campuse_title[]" id="campuse_title[]" value="" placeholder="<?php esc_html_e('Campuse Name','ivdirectories'); ?>">	
																	<input type="text" class=" col-md-2" name="campuse_state[]" id="campuse_state[]" value="" placeholder="<?php esc_html_e('State','ivdirectories'); ?>">
																	<input type="text" class="col-md-2" name="campuse_rate[]" id="campuse_rate[]" value="" placeholder="<?php esc_html_e('Rating e.g.5','ivdirectories'); ?>">
															</div>														
															
													</div>
												<div class="clearfix"><hr></div>
												<div class=" row  ">
													<div class="col-md-12" >
														<button type="button" onclick="add_campuse_field();"  class="btn btn-xs green-haze"><?php esc_html_e('Add More','ivdirectories'); ?></button>
													</div>
												</div>
											</div>
										</div>
									</div>
							<?php
								}
							?>
							<?php
								$coursesProgram=get_option('coursesProgram');
								if($coursesProgram==""){$coursesProgram='yes';}
								if($coursesProgram=="yes"){ ?>	
							<div class="panel panel-default">
										<div class="panel-heading">
											<h4 class="panel-title col-lg-10">
												<a data-toggle="collapse" data-parent="#accordion" href="#collapse212">
													<?php esc_html_e('Courses/Programs','ivdirectories'); ?>
												</a>
											</h4>
											<h4 class="panel-title">
												<a data-toggle="collapse" data-parent="#accordion" href="#collapse212">
													<?php esc_html_e('[ Edit ]','ivdirectories'); ?>
												</a>
											</h4>
										</div>
								<div id="collapse212" class="panel-collapse collapse">
											<div class="panel-body">		
							<div class=" form-group">
							<div class="table-responsive listing-table">
								<?php
									global $wpdb;
									$post_type='courses';
									$per_page=10;$row_strat=0;$row_end=$per_page;									
									
									if(isset($current_user->roles[0]) and $current_user->roles[0]=='administrator'){
										
										$sql="SELECT * FROM $wpdb->posts WHERE post_type IN ('$post_type')  and post_status IN ('publish','pending','draft' )  ORDER BY `ID` DESC";
										}else{
										$sql=$wpdb->prepare("SELECT * FROM $wpdb->posts WHERE post_type IN ('$post_type')  and post_author='%d' and post_status IN ('publish','pending','draft' )  ORDER BY `ID` DESC",$current_user->ID );
									}
									$authpr_post = $wpdb->get_results($sql);
									
									$total_post=count($authpr_post);
									if($total_post>0){
									?>
									<table id="user-data-all" class="display table" cellspacing="0" width="100%">
										<thead>
											
											<tr class="">
												<th><?php  esc_html_e('Serial#','ivdirectories');?></th>
												<th><?php  esc_html_e('Status','ivdirectories');?></th>
												<th><?php  esc_html_e('Title','ivdirectories');?></th>	
												<th><?php  esc_html_e('Estimated Cost','ivdirectories');?></th>
												<!--<th><?php  esc_html_e('Program type','ivdirectories');?></th>
												<th><?php  esc_html_e('Program File','ivdirectories');?></th>
												-->
											</tr>
										</thead>
										<?php
											$i=1;
											foreach ( $authpr_post as $row )
											{
											
											?>
											<tr>
												<td> <?php echo esc_html($i); ?>
													<input type="hidden"  name="program_id<?php echo $row->ID; ?>" id="program_id<?php echo $row->ID; ?>" value="<?php echo $row->ID; ?>" >
													<input type="hidden"  name="programidarr[]" id="programidarr[]" value="<?php echo $row->ID; ?>" >
												</td>
												<td> 
												<?php
												$programsids = get_post_meta($post_edit->ID,'programsids',true);
												$programsids_arr = explode(',',$programsids);
												if (in_array($row->ID, $programsids_arr)) {
												  $checked=" checked";
												}else {
												  $checked="";
												}  
												?>
												<input type="checkbox"  <?php echo $checked; ?> id="programsave[]" name="programsave[]" value="<?php echo $row->ID; ?>">
											
												</td>
												<td style="">
													<a class="profile-desc-link" href="<?php echo get_post_meta($row->ID,'course_link',true); ?>"  target="_blank">
														
													<?php echo esc_html($row->post_title); ?></a>
												</td>
												<td  class="font14">
													<input type="text"  name="estimated_cost<?php echo $row->ID; ?>" id="estimated_cost<?php echo $row->ID; ?>" value="<?php echo get_post_meta($post_edit->ID,'estimated_cost_'.$row->ID,true); ?>" >
												</td>
											</tr>
											<?php
												$i++;
											}
										?>
									</table>
								
								<?php
										}else{
									?>
									<table>
										<tr>
											<td colspan="100%">
												<?php esc_html_e('Currently you have no listings added. Please manage your account from the sidebar on the left.','ivdirectories'); ?>
											</td>
										</tr>
									</table>
									<?php
									}
								?>
							</div>
							</div>
							</div>	
							</div>	
						</div>	
							
							<?php
								}
							?>
						
						
						<div class="panel panel-default">
							<div class="panel-heading">
								<h4 class="panel-title col-lg-10">
									<a data-toggle="collapse" data-parent="#accordion" href="#collapseEight">
										<?php esc_html_e('Speciality(s)','ivdirectories'); ?>
									</a>
								</h4>
								<h4 class="panel-title">
									<a data-toggle="collapse" data-parent="#accordion" href="#collapseEight">
										<?php esc_html_e('[ Edit ]','ivdirectories'); ?>
									</a>
								</h4>
							</div>
							<div id="collapseEight" class="panel-collapse collapse">
								<div class="panel-body">
									<div class=" form-group">
										<div class=" ">
											<?php
												$Specialities =esc_html__('Amazing Compass,Library,Residential Hostel,Industry focus learning,Flexible learning,Knowledge transfer,Teaching skills','ivdirectories');
												$field_set=get_option('iv_listing_Specialities' );
												if($field_set!=""){
													$Specialities=get_option('iv_listing_Specialities' );
												}
												$i=1;
												$Specialities_fields= explode(",",$Specialities);
												$Specialitiess_saved = get_post_meta($post_edit->ID,'Specialities',true);
												$Specialitiess_arr = explode(",",$Specialitiess_saved);
												foreach ( $Specialities_fields as $field_value ) {
													if($field_value!='' ){
														$selected='';
														foreach ( $Specialitiess_arr as $field_1 ) {
															if(trim($field_1)==trim($field_value)){
																$selected='checked';
															}
														}
													?>
													<div class="col-md-4">
														<label class="form-group">
														<input type="checkbox" <?php echo esc_html($selected); ?>  name="Specialities_arr[]" id="Specialities_arr[]" value="<?php echo esc_html($field_value); ?>"> <?php echo esc_html($field_value); ?> </label>
													</div>
													<?php
													}
												}
											?>
										</div>
									</div>
								</div>
							</div>
						</div>
						<div class="panel panel-default">
							<div class="panel-heading">
								<h4 class="panel-title col-lg-10">
									<a data-toggle="collapse" data-parent="#accordion" href="#collapseFour">
										<?php esc_html_e('Contact Info','ivdirectories'); ?>
									</a>
								</h4>
								<h4 class="panel-title">
									<a data-toggle="collapse" data-parent="#accordion" href="#collapseFour">
										<?php esc_html_e('[ Edit ]','ivdirectories'); ?>
									</a>
								</h4>
							</div>
							<div id="collapseFour" class="panel-collapse collapse">
								<div class="panel-body">
									<div class=" form-group">
										<label for="text" class=" control-label"><?php esc_html_e('Phone','ivdirectories'); ?></label>
										<div class="  ">
											<input type="text" class="form-control" name="phone" id="phone" value="<?php echo get_post_meta($post_edit->ID,'phone',true); ?>" placeholder="<?php esc_html_e('Enter Phone Number','ivdirectories'); ?>">
										</div>
									</div>
									<div class=" form-group">
										<label for="text" class=" control-label"><?php esc_html_e('Fax','ivdirectories'); ?></label>
										<div class="  ">
											<input type="text" class="form-control" name="fax" id="fax" value="<?php echo get_post_meta($post_edit->ID,'fax',true); ?>" placeholder="<?php esc_html_e('Enter Fax Number','ivdirectories'); ?>">
										</div>
									</div>
									<div class=" form-group">
										<label for="text" class=" control-label"><?php esc_html_e('Email Address','ivdirectories'); ?></label>
										<div class="  ">
											<input type="text" class="form-control" name="contact-email" id="contact-email" value="<?php echo get_post_meta($post_edit->ID,'contact-email',true); ?>" placeholder="<?php esc_html_e('Enter Email Address','ivdirectories'); ?>">
										</div>
									</div>
									<div class=" form-group">
										<label for="text" class=" control-label"><?php esc_html_e('Web Site','ivdirectories'); ?></label>
										<div class="  ">
											<input type="text" class="form-control" name="contact_web" id="contact_web" value="<?php echo get_post_meta($post_edit->ID,'contact_web',true); ?>" placeholder="<?php esc_html_e('Enter Web Site','ivdirectories'); ?>">
										</div>
									</div>
								</div>
							</div>
						</div>
						<div class="clearfix"></div>
						<div class="panel panel-default">
							<div class="panel-heading">
								<h4 class="panel-title col-lg-10">
									<a data-toggle="collapse" data-parent="#accordion" href="#collapsethirt3">
										<?php esc_html_e('Documents','ivdirectories'); ?>
									</a>
								</h4>
								<h4 class="panel-title">
									<a data-toggle="collapse" data-parent="#accordion" href="#collapsethirt3">
										<?php esc_html_e('[ Edit ]','ivdirectories'); ?>
									</a>
								</h4>
							</div>
							<div id="collapsethirt3" class="panel-collapse collapse">
								<div class="panel-body">
									<div id="docs">
										<?php	$aw=0;
											for($i=0;$i<30;$i++){
												if(get_post_meta($post_edit->ID,'_doc_title_'.$i,true)!='' || get_post_meta($post_edit->ID,'_doc_id_'.$i,true) ){?>
												<div id="doc">
													<div id="doc_delete_<?php echo esc_html($i); ?>">
														<div class=" form-group">
															<span class="pull-right"  >
																<button type="button" onclick="doc_delete(<?php echo esc_html($i); ?>);"  class="btn btn-xs btn-danger">X</button>
															</span>
															<label for="text" class=" control-label"><?php esc_html_e('Doc Title','ivdirectories'); ?>
															</label>
															<div class="  ">
																<input type="text" class="form-control" name="doc_title[]" id="doc_title[]" value="<?php echo get_post_meta($post_edit->ID,'_doc_title_'.$i,true); ?>" placeholder="<?php esc_html_e('Enter doc title','ivdirectories'); ?>">
															</div>
														</div>
														<div class=" form-group mgt10">
															<label for="text" class=" col-md-5 control-label"><?php esc_html_e('PDF Added : ','ivdirectories');
																$filename_link= wp_get_attachment_url( get_post_meta($post_edit->ID,'_doc_id_'.$i,true) );
																$filename= basename(get_attached_file( get_post_meta($post_edit->ID,'_doc_id_'.$i,true) ) );
															echo '<strong> <a target="_blank" href="'.$filename_link.'">'.$filename.'</a></strong>'; ?>  </label>
															<div class="col-md-4" id="doc_image_div">
																<?php
																	if(get_post_meta($post_edit->ID,'_doc_id_'.$i,true)!=''){?>
																	<a  href="javascript:void(0);" onclick="doc_post_image(this);"  >
																		<img width="60px" src="<?php echo wp_iv_directories_URLPATH.'assets/images/PDF1.png'; ?> " >
																		<input type="hidden" name="doc_image_id[]" id="doc_image_id[]" value="<?php echo get_post_meta($post_edit->ID,'_doc_id_'.$i,true); ?>">
																	</a>
																	<?php
																	}else{?>
																	<a  href="javascript:void(0);" onclick="doc_post_image(this);"  >
																		<?php  echo '<img width="60px" src="'. wp_iv_directories_URLPATH.'assets/images/document_add.png">'; ?>
																	</a>
																	<?php
																	}
																?>
															</div>
														</div>
													</div>
												</div>
												<div class="clearfix"></div>
												<hr>
												<?php
													$aw++;
												}
											}
										?>
										<div id="doc">
											<div class=" form-group">
												<label for="text" class=" control-label"><?php esc_html_e('Doc Title','ivdirectories'); ?></label>
												<div class="  ">
													<input type="text" class="form-control" name="doc_title[]" id="doc_title[]" value="" placeholder="<?php esc_html_e('Enter Doc title','ivdirectories'); ?>">
												</div>
											</div>
											<div class=" form-group mgt10">
												<label for="text" class=" col-md-5 control-label"><?php esc_html_e('PDF File','ivdirectories'); ?>  </label>
												<div class="col-md-4" id="award_image_div">
													<a  href="javascript:void(0);" onclick="doc_post_image(this);"  >
														<?php  echo '<img width="60px" src="'. wp_iv_directories_URLPATH.'assets/images/document_add.png">'; ?>
													</a>
												</div>
											</div>
										</div>
									</div>
									<div class=" row  form-group ">
										<div class="col-md-12" >
											<button type="button" onclick="add_doc_field();"  class="btn btn-xs green-haze"><?php esc_html_e('Add More','ivdirectories'); ?></button>
										</div>
									</div>
								</div>
							</div>
						</div>
						<div class="clearfix"></div>
						<div class="panel panel-default">
							<div class="panel-heading">
								<h4 class="panel-title col-lg-10">
									<a data-toggle="collapse" data-parent="#accordion" href="#collapsethirty2">
										<?php esc_html_e('Awards','ivdirectories'); ?>
									</a>
								</h4>
								<h4 class="panel-title">
									<a data-toggle="collapse" data-parent="#accordion" href="#collapsethirty2">
										<?php esc_html_e('[ Edit ]','ivdirectories'); ?>
									</a>
								</h4>
							</div>
							<div id="collapsethirty2" class="panel-collapse collapse">
								<div class="panel-body">
									<?php
										// video, event ,  award
										if($this->check_write_access('award')){
										?>
										<div id="awards">
											<?php	$aw=0;
												for($i=0;$i<20;$i++){
													if(get_post_meta($post_edit->ID,'_award_title_'.$i,true)!='' || get_post_meta($post_edit->ID,'_award_description_'.$i,true) || get_post_meta($post_edit->ID,'_award_year_'.$i,true)|| get_post_meta($post_edit->ID,'_award_image_id_'.$i,true) ){?>
													<div id="award">
														<div id="award_delete_<?php echo esc_html($i); ?>">
															<div class=" form-group">
																<span class="pull-right"  >
																	<button type="button" onclick="award_delete(<?php echo esc_html($i); ?>);"  class="btn btn-xs btn-danger">X</button>
																</span>
																<label for="text" class=" control-label"><?php esc_html_e('Award Title','ivdirectories'); ?>
																</label>
																<div class="  ">
																	<input type="text" class="form-control" name="award_title[]" id="award_title[]" value="<?php echo get_post_meta($post_edit->ID,'_award_title_'.$i,true); ?>" placeholder="<?php esc_html_e('Enter award title','ivdirectories'); ?>">
																</div>
															</div>
															<div class=" form-group">
																<label for="text" class=" control-label"><?php esc_html_e('Award Description','ivdirectories'); ?></label>
																<div class="  ">
																	<input type="text" class="form-control" name="award_description[]" id="award_description[]" value="<?php echo get_post_meta($post_edit->ID,'_award_description_'.$i,true); ?>" placeholder="<?php esc_html_e('Enter Award Description','ivdirectories'); ?>">
																</div>
															</div>
															<div class=" form-group">
																<label for="text" class=" control-label"><?php esc_html_e('Year(s) for which award was received','ivdirectories'); ?></label>
																<div class="  ">
																	<input type="text" class="form-control" name="award_year[]" id="award_year[]" value="<?php echo get_post_meta($post_edit->ID,'_award_year_'.$i,true); ?>" placeholder="<?php esc_html_e('Enter Award Year','ivdirectories'); ?>">
																</div>
															</div>
															<div class=" form-group mgt10">
																<label for="text" class=" col-md-5 control-label"><?php esc_html_e('Award Image','ivdirectories'); ?>  </label>
																<div class="col-md-4" id="award_image_div">
																	<?php
																		if(get_post_meta($post_edit->ID,'_award_image_id_'.$i,true)!=''){?>
																		<a  href="javascript:void(0);" onclick="award_post_image(this);"  >
																			<img src="<?php echo wp_get_attachment_url( get_post_meta($post_edit->ID,'_award_image_id_'.$i,true) ); ?> " >
																			<input type="hidden" name="award_image_id[]" id="award_image_id[]" value="<?php echo get_post_meta($post_edit->ID,'_award_image_id_'.$i,true); ?>">
																		</a>
																		<?php
																		}else{?>
																		<a  href="javascript:void(0);" onclick="award_post_image(this);"  >
																			<?php  echo '<img width="100px" src="'. wp_iv_directories_URLPATH.'assets/images/image-add-icon.png">'; ?>
																		</a>
																		<?php
																		}
																	?>
																</div>
															</div>
														</div>
													</div>
													<div class="clearfix"></div>
													<hr>
													<?php
														$aw++;
													}
												}
												if($aw==0){ ?>
												<div id="award">
													<div class=" form-group">
														<label for="text" class=" control-label"><?php esc_html_e('Award Title','ivdirectories'); ?></label>
														<div class="  ">
															<input type="text" class="form-control" name="award_title[]" id="award_title[]" value="" placeholder="<?php esc_html_e('Enter award title','ivdirectories'); ?>">
														</div>
													</div>
													<div class=" form-group">
														<label for="text" class=" control-label"><?php esc_html_e('Award Description','ivdirectories'); ?></label>
														<div class="  ">
															<input type="text" class="form-control" name="award_description[]" id="award_description[]" value="" placeholder="<?php esc_html_e('Enter Award Description','ivdirectories'); ?>">
														</div>
													</div>
													<div class=" form-group">
														<label for="text" class=" control-label"><?php esc_html_e('Year(s) for which award was received','ivdirectories'); ?></label>
														<div class="  ">
															<input type="text" class="form-control" name="award_year[]" id="award_year[]" value="" placeholder="<?php esc_html_e('Enter Award Year','ivdirectories'); ?>">
														</div>
													</div>
													<div class="form-group mgt10">
														<label for="text" class=" col-md-5 control-label"><?php esc_html_e('Award Image','ivdirectories'); ?>  </label>
														<div class="col-md-4" id="award_image_div">
															<a  href="javascript:void(0);" onclick="award_post_image(this);"  >
																<?php  echo '<img width="100px" src="'. wp_iv_directories_URLPATH.'assets/images/image-add-icon.png">'; ?>
															</a>
														</div>
													</div>
												</div>
												<?php
												}
											?>
										</div>
										<div class=" row  form-group ">
											<div class="col-md-12" >
												<button type="button" onclick="add_award_field();"  class="btn btn-xs green-haze"><?php esc_html_e('Add More','ivdirectories'); ?></button>
											</div>
										</div>
										<?php
											}else{
											esc_html_e('Please upgrade your account to add Award ','ivdirectories');
										}
									?>
								</div>
							</div>
						</div>
						
						<div class="clearfix"></div>
						<div class="panel panel-default">
							<div class="panel-heading">
								<h4 class="panel-title col-lg-10">
									<a data-toggle="collapse" data-parent="#accordion" href="#collapseThree">
										<?php esc_html_e('Videos','ivdirectories'); ?>
									</a>
								</h4>
								<h4 class="panel-title">
									<a data-toggle="collapse" data-parent="#accordion" href="#collapseThree">
										<?php esc_html_e('[ Edit ]','ivdirectories'); ?>
									</a>
								</h4>
							</div>
							<div id="collapseThree" class="panel-collapse collapse">
								<div class="panel-body">
									<?php
										// video, event , coupon , vip_badge
										if($this->check_write_access('video')){
										?>
										<div class=" form-group">
											<label for="text" class=" control-label"><?php esc_html_e('Youtube','ivdirectories'); ?></label>
											<div class="  ">
												<input type="text" class="form-control" name="youtube" id="youtube" value="<?php echo get_post_meta($post_edit->ID,'youtube',true); ?>" placeholder="<?php esc_html_e('Enter Youtube video ID, e.g : bU1QPtOZQZU ','ivdirectories'); ?>">
											</div>
										</div>
										<div class=" form-group">
											<label for="text" class=" control-label"><?php esc_html_e('Vimeo','ivdirectories'); ?></label>
											<div class="  ">
												<input type="text" class="form-control" name="vimeo" id="vimeo" value="<?php echo get_post_meta($post_edit->ID,'vimeo',true); ?>" placeholder="<?php esc_html_e('Enter vimeo ID, e.g : 134173961','ivdirectories'); ?>">
											</div>
										</div>
										<?php
											}else{
											esc_html_e('Please upgrade your account to add video ','ivdirectories');
										}
									?>
								</div>
							</div>
						</div>
						<div class="clearfix"></div>
						<div class="panel panel-default">
							<div class="panel-heading">
								<h4 class="panel-title col-lg-10">
									<a data-toggle="collapse" data-parent="#accordion" href="#collapseFive">
										<?php esc_html_e('Social Profiles','ivdirectories'); ?>
									</a>
								</h4>
								<h4 class="panel-title">
									<a data-toggle="collapse" data-parent="#accordion" href="#collapseFive">
										<?php esc_html_e('[ Edit ]','ivdirectories'); ?>
									</a>
								</h4>
							</div>
							<div id="collapseFive" class="panel-collapse collapse">
								<div class="panel-body">
									<div class="form-group">
										<label class="control-label"><?php esc_html_e('FaceBook', 'ivdirectories' ); ?></label>
										<input type="text" name="facebook" id="facebook" value="<?php echo get_post_meta($post_edit->ID,'facebook',true); ?>" class="form-control"/>
									</div>
									<div class="form-group">
										<label class="control-label"><?php esc_html_e('Linkedin', 'ivdirectories' ); ?></label>
										<input type="text" name="linkedin" id="linkedin" value="<?php echo get_post_meta($post_edit->ID,'linkedin',true); ?>" class="form-control"/>
									</div>
									<div class="form-group">
										<label class="control-label"><?php esc_html_e('Twitter', 'ivdirectories' ); ?></label>
										<input type="text" name="twitter" id="twitter" value="<?php echo get_post_meta($post_edit->ID,'twitter',true); ?>" class="form-control"/>
									</div>
									
									<div class="form-group">
										<label class="control-label"><?php esc_html_e('Pinterest', 'ivdirectories' ); ?></label>
										<input type="text" name="pinterest" id="pinterest" value="<?php echo get_post_meta($post_edit->ID,'pinterest',true); ?>"  class="form-control"/>
									</div>
									<div class="form-group">
										<label class="control-label"> <?php esc_html_e('Instagram', 'ivdirectories' ); ?></label>
										<input type="text" name="instagram" id="instagram" value="<?php echo get_post_meta($post_edit->ID,'instagram',true); ?>"  class="form-control"/>
									</div>
								</div>
							</div>
						</div>
						<div class="clearfix"></div>
						<div class="panel panel-default">
							<div class="panel-heading">
								<h4 class="panel-title col-lg-10">
									<a data-toggle="collapse" data-parent="#accordion" href="#collapseTwo">
										<?php esc_html_e('Additional Info','ivdirectories'); ?>
									</a>
								</h4>
								<h4 class="panel-title">
									<a data-toggle="collapse" data-parent="#accordion" href="#collapseTwo">
										<?php esc_html_e('[ Edit ]','ivdirectories'); ?>
									</a>
								</h4>
							</div>
							<div id="collapseTwo" class="panel-collapse collapse">
								<div class="panel-body">
									<?php
										$default_fields = array();
										$field_set=get_option('iv_directories_fields' );
										if($field_set!=""){
											$default_fields=get_option('iv_directories_fields' );
											}else{
											$default_fields['Totalenrollment']='Total enrollment';
											$default_fields['Undergraduate_graduate_ratio']='Undergraduate/graduate ratio ';
											$default_fields['No_of_international_students']='No. of international students ';
											$default_fields['pers_of international_students']=' % of international students';
											$default_fields['no_of_faculty']='No. of faculty';
											$default_fields['Student_faculty_ratio']='Student faculty ratio';
											$default_fields['no_of_staff']='No. of staff';
											$default_fields['Annual_revenue ']='Annual revenue';
										}
										$i=1;
										foreach ( $default_fields as $field_key => $field_value ) { ?>
										<div class="form-group">
											<label class="control-label"><?php echo esc_html_e($field_value); ?></label>
											<input type="text" placeholder="<?php echo 'Enter '.esc_html($field_value);?>" name="<?php echo esc_html($field_key);?>" id="<?php echo esc_html($field_key);?>"  class="form-control" value="<?php echo get_post_meta($post_edit->ID,$field_key,true); ?>"/>
										</div>
										<?php
										}
									?>
								</div>
							</div>
						</div>
						<div class="panel panel-default">
							<div class="panel-heading">
								<h4 class="panel-title col-lg-10">
									<a data-toggle="collapse" data-parent="#accordion" href="#collapseOne">
										<?php esc_html_e('Working Time','ivdirectories'); ?>
									</a>
								</h4>
								<h4 class="panel-title">
									<a data-toggle="collapse" data-parent="#accordion" href="#collapseOne">
										<?php esc_html_e('[ Edit ]','ivdirectories'); ?>
									</a>
								</h4>
							</div>
							<div id="collapseOne" class="panel-collapse collapse">
								<div class="panel-body">
									<?php
										$opeing_days = get_post_meta($post_edit->ID ,'_opening_time',true);
										if($opeing_days!=''){?>
										<?php
											$i=1;
											if(sizeof($opeing_days)>0){
												foreach($opeing_days as $key => $item){
													$day_time = explode("|", $item);
													echo '<div id="old_days'. $i .'">
													<div class="col-md-4"><h5>'.$key.'</h5></div> <div class="col-md-7"> <h5>: '.$day_time[0].' - '.$day_time[1].'</h5></div><div class="col-md-1"> <button type="button" onclick="remove_old_day('.$i.');"  class="btn btn-xs btn-danger">X</button>
													</div>
													<input type="hidden" name="day_name[]" id="day_name[]" value="'.$key.'">
													<input type="hidden" name="day_value1[]" id="day_value1[]" value="'.$day_time[0].'">
													<input type="hidden" name="day_value2[]" id="day_value2[]" value="'.$day_time[1].'">
													</div>
													';
													$i++;
												}
											}
										}
									?>
									<div id="day_field_div">
										<div class=" row form-group " id="day-row1" >
											<div class=" col-md-4">
												<select name="day_name[]" id="day_name[]" class="form-control">
													<option value=""></option>
													<option value="<?php esc_html_e('Monday','ivdirectories'); ?> "> <?php esc_html_e('Monday','ivdirectories'); ?>  </option>
													<option value="<?php esc_html_e('Tuesday','ivdirectories'); ?>"><?php esc_html_e('Tuesday','ivdirectories'); ?></option>
													<option value="<?php esc_html_e('Wednesday','ivdirectories'); ?>"><?php esc_html_e('Wednesday','ivdirectories'); ?></option>
													<option value="<?php esc_html_e('Thursday','ivdirectories'); ?>"><?php esc_html_e('Thursday','ivdirectories'); ?></option>
													<option value="<?php esc_html_e('Friday','ivdirectories'); ?>"><?php esc_html_e('Friday','ivdirectories'); ?></option>
													<option value="<?php esc_html_e('Saturday','ivdirectories'); ?>"><?php esc_html_e('Saturday','ivdirectories'); ?></option>
													<option value="<?php esc_html_e('Sunday','ivdirectories'); ?>"><?php esc_html_e('Sunday','ivdirectories'); ?></option>
												</select>
											</div>
											<div  class=" col-md-4">
												<input type="text" placeholder="<?php esc_html_e('12:00 AM','ivdirectories'); ?> " name="day_value1[]" id="day_value1[]"  class="form-control" />
											</div>
											<div  class="col-md-4">
												<input type="text" placeholder="<?php esc_html_e('12:00 AM','ivdirectories'); ?> " name="day_value2[]" id="day_value2[]"  class="form-control" />
											</div>
										</div>
									</div>
									<div class=" row  form-group ">
										<div class="col-md-12" >
											<button type="button" onclick="add_day_field();"  class="btn btn-xs green-haze"><?php esc_html_e('Add More','ivdirectories'); ?></button>
										</div>
									</div>
								</div>
							</div>
						</div>
						<div class="clearfix"></div>
						<div class="panel panel-default">
							<div class="panel-heading">
								<h4 class="panel-title col-lg-10">
									<a data-toggle="collapse" data-parent="#accordion" href="#collapseSix">
										<?php esc_html_e('Event','ivdirectories'); ?>
									</a>
								</h4>
								<h4 class="panel-title">
									<a data-toggle="collapse" data-parent="#accordion" href="#collapseSix">
										<?php esc_html_e('[ Edit ]','ivdirectories'); ?>
									</a>
								</h4>
							</div>
							<div id="collapseSix" class="panel-collapse collapse">
								<div class="panel-body">
									<?php
										// video, event , coupon , vip_badge , booking
										if($this->check_write_access('event')){
										?>
										<div class=" form-group">
											<label for="text" class=" control-label"><?php esc_html_e('Event Title','ivdirectories'); ?></label>
											<input type="text" class="form-control" name="event-title" id="event-title" value="<?php echo get_post_meta($post_edit->ID,'event_title',true); ?>" placeholder="<?php esc_html_e('Enter Title Here','ivdirectories'); ?>">
										</div>
										<div class=" form-group">
											<label for="text" class=" control-label"><?php esc_html_e('Event Detail','ivdirectories'); ?></label>
											<?php
												$settings_a = array(
												'textarea_rows' =>10,
												'editor_class' => 'form-control'
												);
												$content_client = get_post_meta($post_edit->ID,'event_detail',true);
												$editor_id = 'event-detail';
											?>
											<textarea id="event-detail" name="event-detail"  rows="4" class="form-control" > <?php echo esc_html($content_client); ?> </textarea>
										</div>
										<div class=" row form-group mgt10">
											<label for="text" class=" col-md-5 control-label"><?php esc_html_e('Event Image','ivdirectories'); ?>  </label>
											<div class="col-md-4" id="event_image_div">
												<?php
													if(get_post_meta($post_edit->ID,'_event_image_id',true)!=''){
														$event_image_src= wp_get_attachment_url( get_post_meta($post_edit->ID,'_event_image_id',true) );
													?>
													<img  class="img-responsive"  src="<?php echo esc_html($event_image_src); ?>">
													<?php
													}else{ ?>
													<a  href="javascript:void(0);" onclick="event_post_image('event_image_div');"  >
														<?php  echo '<img width="100px" src="'. wp_iv_directories_URLPATH.'assets/images/image-add-icon.png">'; ?>
													</a>
													<?php
													}
												?>
											</div>
											<div class="col-md-3" id="event_image_edit">
												<?php
													if(get_post_meta($post_edit->ID,'_event_image_id',true)!=''){
													?>
													<button type="button" onclick="event_post_image('event_image_div');"  class="btn btn-xs green-haze"><?php esc_html_e('Edit', 'ivdirectories' ); ?></button> &nbsp;<button type="button" onclick="remove_event_image('event_image_div');"  class="btn btn-xs green-haze"><?php esc_html_e('Remove', 'ivdirectories' ); ?></button>
													<?php
													}else{ ?>
													<button type="button" onclick="event_post_image('event_image_div');"  class="btn btn-xs green-haze"><?php esc_html_e('Add','ivdirectories'); ?></button>
													<?php
													}
												?>
											</div>
											<input type="hidden" name="event_image_id" id="event_image_id" value="<?php echo get_post_meta($post_edit->ID,'_event_image_id',true); ?>" >
										</div>
										<?php
											}else{
											esc_html_e('Please upgrade your account to add event ','ivdirectories');
										}
									?>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
		<input type="hidden" name="listing_data_submit" id="listing_data_submit" value="yes">
		<!-- END PROFILE CONTENT -->
	</div>
</div>
<?php
	wp_enqueue_script('iv_directories-ar-script-27', wp_iv_directories_URLPATH . 'admin/files/js/add-edit-listing.js');
	wp_localize_script('iv_directories-ar-script-27', 'dirpro_data', array(
	'ajaxurl' 			=> admin_url( 'admin-ajax.php' ),
	'loading_image'		=> '<img src="'.wp_iv_directories_URLPATH.'admin/files/images/loader.gif">',
	'current_user_id'	=>get_current_user_id(),
	'image10'	=>esc_html__('image','ivdirectories'),
	'myaccount'=> wp_create_nonce("myaccount"),
	'permalink'=> get_permalink(),
	'wp_iv_directories_URLPATH'=> wp_iv_directories_URLPATH,
	) );
	
	wp_enqueue_script('iv_directories-ar-map', wp_iv_directories_URLPATH . 'admin/files/js/add-edit-listing-map.js');
	wp_localize_script('iv_directories-ar-map', 'dirpro_map_data', array(
	'ajaxurl' 			=> admin_url( 'admin-ajax.php' ),
	'latitude' =>	get_post_meta($post_edit->ID,'latitude',true),
	'longitude'=> get_post_meta($post_edit->ID,'longitude',true),		
	) );
?>